%global dlrn 1
%define upstream_version 5.2.0
%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%define upstream_name tripleo-heat-templates
%define old_version_name newton

Name:          openstack-%{upstream_name}-compat
Summary:       Heat templates for TripleO old version support
Version:       5.2.0
Release:       25%{?dist}
License:       ASL 2.0
Group:         System Environment/Base
URL:           https://wiki.openstack.org/wiki/TripleO
Source0:       https://tarballs.openstack.org/tripleo-heat-templates/tripleo-heat-templates-%{upstream_version}.tar.gz

#
# patches_base=+1
#
Patch0001: 0001-OSP-Only-Add-the-puppet-pacemaker-templates-to-the-d.patch
Patch0002: 0002-downstream-only-UpgradeInitCommand-for-OSP.patch
Patch0003: 0003-downstream-only-UpgradeInitCommand-update-to-switch-.patch
Patch0004: 0004-downstream-only-Retain-existing-ComputeHostnameForma.patch
Patch0005: 0005-downstream-only-configure-Horizon-to-point-on-OSP-do.patch
Patch0006: 0006-Enables-auto-detection-for-VIP-interfaces.patch
Patch0007: 0007-Make-the-openvswitch-2.4-2.5-upgrade-more-robust.patch
Patch0008: 0008-Setting-networking-odl-v2-as-a-mechanism-driver.patch
Patch0009: 0009-Adds-missing-firewall-rules-for-OpenDaylight-API-ser.patch
Patch0010: 0010-Adds-missing-OpenDaylight-username-password-from-ODL.patch
Patch0011: 0011-Add-support-for-live-migration-over-ssh.patch
Patch0012: 0012-9-10-Add-openstack-nova-migration-to-compute.patch
Patch0013: 0013-Install-openstack-nova-migration-during-minor-update.patch
Patch0014: 0014-Ignore-systemctl-return-code-in-yum_update.sh.patch
Patch0015: 0015-Disable-exit-on-error-for-pacemaker-commands-for-upd.patch
Patch0016: 0016-Touch-etc-httpd-conf.d-ssl.conf.patch
Patch0017: 0017-M-N-Ensure-mod_ssl-is-installed-during-upgrade.patch
Patch0018: 0018-Add-NovaLibvirtNetwork.patch
Patch0019: 0019-Newton-only-Manually-touch-ssl.conf-before-installin.patch
Patch0020: 0020-Newton-only-Enable-services-in-the-major-upgrade-pac.patch
Patch0021: 0021-Adding-the-ip_conntrack_proto_sctp-kernel-module.patch
Patch0022: 0022-Temporary-UCSM-mapping-files-should-be-opened-with-w.patch
Patch0023: 0023-Adds-default-Keystone-region-to-regionOne.patch
Patch0024: 0024-Fix-for-AllNodesExtraConfig-and-fix-environment-file.patch
Patch0025: 0025-Fix-bug-when-using-multiple-DeployArtifactURLs.patch
Patch0026: 0026-Use-df-instead-of-findmnt-in-cephstorage-upgrade-scr.patch
Patch0027: 0027-scenario001-pingtest-remove-gnocchi_res_alarm.patch
Patch0028: 0028-DB-connection-prevent-src-address-from-binding-to-a-.patch
Patch0029: 0029-newton-Import-multinode-pingtest-from-tripleo-ci.patch
Patch0030: 0030-ceph-rgw-add-missing-user-parameter.patch
Patch0031: 0031-Allow-to-separate-Horizon-from-Neutron.patch
Patch0032: 0032-Allow-the-override-of-pacemaker-corosync-settle_trie.patch
Patch0033: 0033-Remove-Gemfile-and-Rakefile.patch
Patch0034: 0034-net-config-multinode-make-controlplane-int-idempoten.patch
Patch0035: 0035-Add-new-environment-for-debug.patch
Patch0036: 0036-Run-online_data_migrations-during-minor-updates.patch
Patch0037: 0037-backport-multinode_major_upgrade.yaml-environment.patch
Patch0038: 0038-Synchronize-NetworkDeployment-inputs-for-generic-rol.patch
Patch0039: 0039-multinode-upgrade-add-nova-services-to-environment.patch
Patch0040: 0040-Update-ci-environment-for-multinode-jobs-to-support-.patch
Patch0041: 0041-multinode_major_upgrade-enable-Pacemaker.patch
Patch0042: 0042-Deploy-NTP-with-puppet-tripleo-profile.patch
Patch0043: 0043-Disable-all-repos-during-rhel-registration.patch
Patch0044: 0044-Add-retry-to-RHEL-registration.patch
Patch0045: 0045-Adds-http-proxy-support-for-registering-RHEL-overclo.patch
Patch0046: 0046-Use-disable-in-subscription-manager-to-avoid-shell-e.patch
Patch0047: 0047-Fixes-multiple-issues-with-retry-function-in-rhel-re.patch
Patch0048: 0048-Pick-dynamically-the-first-node-for-stack-validation.patch
Patch0049: 0049-Composable-services-support-for-Cinder-Dell-EMC-PS-S.patch
Patch0050: 0050-Composable-service-support-for-Cinder-Dell-EMC-Stora.patch
Patch0051: 0051-Only-set-EnableConfigPurge-on-major-upgrades.patch
Patch0052: 0052-Update-the-Nova-Endpoint-information-for-Cinder.patch
Patch0053: 0053-Configure-VNC-Server-listen-address-through-t-h-t.patch
Patch0054: 0054-Re-Add-bigswitch-agent-support.patch
Patch0055: 0055-yum_update.sh-Use-the-yum-parameter-check-update.patch
Patch0056: 0056-newton-scenario001-enable-ceph.patch
Patch0057: 0057-Add-missing-TripleO-services-to-ci-multinode.patch
Patch0058: 0058-Deploy-CI-scenarios-with-Pacemaker.patch
Patch0059: 0059-scenario001-newton-deploy-cinder-with-rbd-backend.patch
Patch0060: 0060-Set-manila-default_share_type-config-option.patch
Patch0061: 0061-newton-scenario001-enable-ceph.patch
Patch0062: 0062-Automatically-backup-and-restore-Swift-rings-from-th.patch
Patch0063: 0063-Remove-the-openvswitch-special-case-upgrade-code.patch
Patch0064: 0064-Remove-ceph-mds-service-from-newton-scenario-004.patch
Patch0065: 0065-Quote-empty-strings-in-manila-netapp-driver.patch
Patch0066: 0066-Make-ServiceNetMap-support-custom-network-names.patch
Patch0067: 0067-Moved-some-variable-definitions-to-global-scope.patch
Patch0068: 0068-Make-sure-PrePuppet-runs-before-any-Deployment_Step.patch
Patch0069: 0069-Add-bindep-support.patch
Patch0070: 0070-Only-set-EnableConfigPurge-on-major-upgrades.patch
Patch0071: 0071-Increase-libvirt-qemu.conf-max_files-and-max_process.patch
Patch0072: 0072-Enables-increasing-mariadb-open-files-for-noha-deplo.patch
Patch0073: 0073-Add-special-case-upgrade-from-openvswitch-2.5.0-14.patch
Patch0074: 0074-NEWTON-ONLY-Fix-Ceph-upgrade-from-Hammer-to-Jewel-10.patch
Patch0075: 0075-Ensure-AllNodesExtraConfig-runs-before-AllNodesDeplo.patch
Patch0076: 0076-downstream-only-UpgradeInitCommand-for-OSP.patch
Patch0077: 0077-Add-support-for-live-migration-over-ssh.patch
Patch0078: 0078-Only-set-EnableConfigPurge-on-major-upgrades.patch
Patch0079: 0079-newton-scenario001-enable-ceph.patch
Patch0080: 0080-Enable-arp_accept-for-all-interfaces.patch
Patch0081: 0081-downstream-only-Remove-duplicate-lines-in-subscripti.patch
Patch0082: 0082-Reconfigure-interfaces-before-updating-openvswitch.patch
Patch0083: 0083-Expose-metric-delay-processing-metric.patch
Patch0084: 0084-Fix-conntrack-proto-sctp-module.patch

BuildArch:     noarch
BuildRequires: python2-devel
BuildRequires: python-setuptools
BuildRequires: python-d2to1
BuildRequires: python-pbr

Requires:      PyYAML
Requires:      openstack-%{upstream_name}

%description
OpenStack TripleO Heat Templates is a collection of templates and tools for
building Heat Templates to do deployments of OpenStack.  These templates provide support for the clouds running the previous upstream version of OpenStack.

%prep
%setup -q -n tripleo-heat-templates-%{upstream_version}

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1
%patch0028 -p1
%patch0029 -p1
%patch0030 -p1
%patch0031 -p1
%patch0032 -p1
%patch0033 -p1
%patch0034 -p1
%patch0035 -p1
%patch0036 -p1
%patch0037 -p1
%patch0038 -p1
%patch0039 -p1
%patch0040 -p1
%patch0041 -p1
%patch0042 -p1
%patch0043 -p1
%patch0044 -p1
%patch0045 -p1
%patch0046 -p1
%patch0047 -p1
%patch0048 -p1
%patch0049 -p1
%patch0050 -p1
%patch0051 -p1
%patch0052 -p1
%patch0053 -p1
%patch0054 -p1
%patch0055 -p1
%patch0056 -p1
%patch0057 -p1
%patch0058 -p1
%patch0059 -p1
%patch0060 -p1
%patch0061 -p1
%patch0062 -p1
%patch0063 -p1
%patch0064 -p1
%patch0065 -p1
%patch0066 -p1
%patch0067 -p1
%patch0068 -p1
%patch0069 -p1
%patch0070 -p1
%patch0071 -p1
%patch0072 -p1
%patch0073 -p1
%patch0074 -p1
%patch0075 -p1
%patch0076 -p1
%patch0077 -p1
%patch0078 -p1
%patch0079 -p1
%patch0080 -p1
%patch0081 -p1
%patch0082 -p1
%patch0083 -p1
%patch0084 -p1

%build
%{__python2} setup.py build

%install
%{__python2} setup.py install -O1 --skip-build --root=%{buildroot}
install -d -m 755 %{buildroot}/%{_datadir}/openstack-%{upstream_name}/compat
cp -ar *.yaml %{buildroot}/%{_datadir}/openstack-%{upstream_name}/compat
cp -ar puppet %{buildroot}/%{_datadir}/openstack-%{upstream_name}/compat
cp -ar docker %{buildroot}/%{_datadir}/openstack-%{upstream_name}/compat
cp -ar firstboot %{buildroot}/%{_datadir}/openstack-%{upstream_name}/compat
cp -ar extraconfig %{buildroot}/%{_datadir}/openstack-%{upstream_name}/compat
cp -ar environments %{buildroot}/%{_datadir}/openstack-%{upstream_name}/compat
cp -ar network %{buildroot}/%{_datadir}/openstack-%{upstream_name}/compat
cp -ar validation-scripts %{buildroot}/%{_datadir}/openstack-%{upstream_name}/compat
if [ -d examples ]; then
  rm -rf examples
fi

if [ -d %{buildroot}/%{python2_sitelib}/tripleo_heat_merge ]; then
  rm -rf %{buildroot}/%{python2_sitelib}/tripleo_heat_merge
  rm -f %{buildroot}/%{_bindir}/tripleo-heat-merge
fi

ln -s compat %{buildroot}/%{_datadir}/openstack-%{upstream_name}/%{old_version_name}

%files
%doc README*
%license LICENSE
%{python2_sitelib}/tripleo_heat_templates-*.egg-info
%{_datadir}/openstack-%{upstream_name}/compat
%{_datadir}/openstack-%{upstream_name}/%{old_version_name}

%changelog
* Thu Jul 27 2017 Mike Burns <mburns@redhat.com> 5.2.0-25
- Fix conntrack proto sctp module (rhbz#1470209)
- Expose metric delay processing metric (rhbz#1454939)

* Tue Jun 27 2017 Mike Burns <mburns@redhat.com> 5.2.0-20
- Reconfigure interfaces before updating openvswitch
- [downstream only] Remove duplicate lines in subscription.
- Enable arp_accept for all interfaces (rhbz#1457506)
- Only set EnableConfigPurge on major upgrades (rhbz#1421883)
- Add support for live migration over ssh (rhbz#1428241)
- Ensure AllNodesExtraConfig runs before AllNodesDeploySteps
- [NEWTON-ONLY] Fix Ceph upgrade from Hammer to Jewel >= 10.2.4
- Add special case upgrade from openvswitch 2.5.0-14
- Enables increasing mariadb open files for noha deployments
- Increase libvirt/qemu.conf max_files and max_processes
- Only set EnableConfigPurge on major upgrades
- Add bindep support
- Make sure PrePuppet runs before any Deployment_Step
- Moved some variable definitions to global scope
- Make ServiceNetMap support custom network names
- Quote empty strings in manila netapp driver
- Remove ceph mds service from newton scenario 004
- Remove the openvswitch special case upgrade code
- Automatically backup and restore Swift rings from the undercloud
- Set manila default_share_type config option
- yum_update.sh - Use the yum parameter: check-update (rhbz#1440217)
- Re-Add bigswitch agent support (rhbz#1438893)
- Configure VNC Server listen address through t-h-t (rhbz#1431674)
- Update the Nova Endpoint information for Cinder (rhbz#1425968)
- Only set EnableConfigPurge on major upgrades (rhbz#1421883)
- Composable service support for Cinder Dell EMC Storage Center (rhbz#1430078)
- Composable services support for Cinder Dell EMC PS Series (rhbz#1430071)
- Pick dynamically the first node for stack validation (rhbz#1436387)
- Fixes multiple issues with retry function in rhel-registration. (rhbz#1314480)
- Use --disable= in subscription-manager to avoid shell expansion. (rhbz#1314480)
- Adds http proxy support for registering RHEL overcloud nodes (rhbz#1314480)
- Add retry to RHEL registration (rhbz#1314480)
- Disable all repos during rhel registration (rhbz#1314480)
- Deploy NTP with puppet-tripleo profile (rhbz#1430833)
- Fix for AllNodesExtraConfig and fix environment files to create swap files/partitions (rhbz#1415103)
- [Newton-only] Enable services in the major-upgrade-pacemaker step
- [Newton only] - Manually touch ssl.conf before installing mod_ssl
- Add NovaLibvirtNetwork (rhbz#1448062)
- [M->N] Ensure mod_ssl is installed during upgrade. (rhbz#1441982)
- Touch /etc/httpd/conf.d/ssl.conf (rhbz#1441982)
- Ignore systemctl return code in yum_update.sh (rhbz#1414779 rhbz#1416228)
- Install openstack-nova-migration during minor update of OSP10
- [9->10] Add openstack-nova-migration to compute (rhbz#1428241)
- Add support for live migration over ssh (rhbz#1428241)

* Fri Mar 17 2017 Mike Burns <mburns@redhat.com> 5.2.0-7
- scenario001/newton: deploy cinder with rbd backend
- Deploy CI scenarios with Pacemaker
- multinode_major_upgrade: enable Pacemaker
- Update ci environment for multinode jobs to support Ceph
- multinode/upgrade: add nova services to environment
- Synchronize NetworkDeployment inputs for generic roles
- backport multinode_major_upgrade.yaml environment
- Add missing TripleO services to ci/multinode
- Run online_data_migrations during minor updates.
- Add new environment for debug
- net-config-multinode: make controlplane int idempotent
- Remove Gemfile and Rakefile
- newton/scenario001: enable ceph
- Allow the override of pacemaker::corosync::settle_tries
- Allow to separate Horizon from Neutron
- ceph-rgw: add missing user parameter
- (newton) Import multinode + pingtest from tripleo-ci
- DB connection: prevent src address from binding to a VIP
- scenario001/pingtest: remove gnocchi_res_alarm
- Use df instead of findmnt in cephstorage upgrade scripts
- Fix bug when using multiple DeployArtifactURLs
- Disable exit on error for pacemaker commands for update flow
- Fix for AllNodesExtraConfig and fix environment files to create swap files/partitions (rhbz#1415103)
- Adds default Keystone region to regionOne
- Temporary UCSM mapping files should be opened with write mode (rhbz#1427712)
- Adding the ip_conntrack_proto_sctp kernel module (rhbz#1426912)
- Adds missing OpenDaylight username/password from ODL OVS service
- Adds missing firewall rules for OpenDaylight API service
- Setting networking-odl v2 as a mechanism driver
- Make the openvswitch 2.4->2.5 upgrade more robust
- Enables auto-detection for VIP interfaces
- [downstream-only] configure Horizon to point on OSP doc
- [downstream only] Retain existing ComputeHostnameFormat in OSP10
- [downstream only] UpgradeInitCommand update to switch Ceph repos (rhbz#1381241)
- [downstream only] UpgradeInitCommand for OSP (rhbz#1361177)
- [OSP Only] Add the puppet-pacemaker templates to the default OC deployment in THT (rhbz#1348188)

